#import "IosRotateImagePlugin.h"


@implementation IosRotateImagePlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"ios_rotate_image"
            binaryMessenger:[registrar messenger]];
  IosRotateImagePlugin* instance = [[IosRotateImagePlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"rotateImage" isEqualToString:call.method]) {
      NSString *path = call.arguments[@"path"];
      NSString *side = call.arguments[@"side"];
      // check if a file exists
      if ([UIImage imageNamed:path]) {
          // if it exists, change the rotation mode
          UIImage * landscapeImage = [UIImage imageNamed:path];
          UIImage * portraitImage = [[UIImage alloc] initWithCGImage: landscapeImage.CGImage
                                                               scale: 1.0
                                                         orientation: UIImageOrientationRight];
          NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
          NSString* documentsDirectory = [paths objectAtIndex:0];
          NSString* path = [documentsDirectory stringByAppendingPathComponent: @"test.png"];
          NSData* data = UIImagePNGRepresentation(portraitImage);
          [data writeToFile:path atomically:YES];
          result(path);
      } else {
          result(FlutterMethodNotImplemented);
          return;
      }
      result(@"OK");
  } else {
    result(FlutterMethodNotImplemented);
    return;
  }
}

@end
